#!/usr/bin/python

import tkinter as tk
from tkinter import *
from tkinter.ttk import *
import ctypes
import struct
import unittest
import logging
import time
import os
import numpy as np

from subprocess import Popen
from os import path, kill
import snap7
from snap7.snap7exceptions import Snap7Exception
from snap7.snap7types import *
from snap7.util import *
from time import strftime, localtime
from PIL import Image, ImageTk

global listraw
listraw = []

# Close app
def exitProgram():
    client.disconnect()
    client.destroy()
    win.quit()
    win.destroy()

value = 0

# PLC Connection 
def conn():
    ip = '10.100.8.12'
    tcpport = 102
    db_number = 1
    rack = 0
    slot = 1
    global client
    client = snap7.client.Client()
    def check_conn():
        if client.get_connected() != 1:
            client.connect(ip, rack, slot, tcpport)
            #print ("Connect")
        win.after(1000, check_conn)
    check_conn()

# read array of actuator statuses     
def read_stat_db():
    def read_db():
        global state
        state = client.db_read(1, 0, 5)
        win.after(1000, read_db)
    read_db()

# read Q0 not used now
def read_Tag_Value(label):
    value = 0
    listraw = []
    def read():
        global value
        value = client.ab_read(0, 1)
        if len(listraw) > 9:
            listraw.pop()
        listraw.insert(0, strftime("%H:%M:%S", localtime()) + ":  QB0 " + str(value[0]))
        label['values'] = listraw
        label.current(0)
        label.after(1000, read)
    read()

# check actuator status change
def check_state():
    global state_old
    state_old = []
    def compare_state():
        global state_old
        if state_old == []:
            state_old = list(state)           
        if np.array_equiv(state_old, state) == False:
            for i in range(len(state)):
                if state[i] != state_old[i]:
                    if i!=3 or (i==3 and (state[i]==0 or state[i]==100)):
                        al_text = alarm_text(i, state[i])    
                        alarm(alarmList, al_text)
        state_old = list(state)
        win.after(300, compare_state)
    compare_state()        

# Return alarm text
# alarm_text(actuator status byte, actuator status value)
def alarm_text(stat_b, stat_v):
    text = ""
    if stat_b == 0:
        if stat_v == 0:
            text = "M1 motor stopped."
        elif stat_v == 1:
            text = "M1 motor started."
        elif stat_v == 2:
            text = "M1 motor failed (V1 closed)."
    elif stat_b == 1:
        if stat_v == 0:
            text = "V1 valve closed."
        elif stat_v == 1:
            text = "V1 valve opened."
        elif stat_v == 2:
            text = "V1 valve failed."
    elif stat_b == 2:
        if stat_v == 0:
            text = "V2 valve closed."
        elif stat_v == 1:
            text = "V2 valve opened."
        elif stat_v == 2:
            text = "V2 valve failed."
    elif stat_b == 3:
        if stat_v == 0:
            text = "Tank is empty."
        elif stat_v == 100:
            text = "Tank is full"
    elif stat_b == 4:
        if stat_v == 2:
            text = "HL reached."
        elif stat_v == 1:
            text = "HL left."
    return(text)
    
# write alarm to alarm list
# alarm(listbox, text of alarm)
def alarm(label, text):
    global listraw
    if len(listraw) > 9:
        listraw.pop()
    listraw.insert(0, strftime("%H:%M:%S", localtime()) + ": " + text)
    label['values'] = listraw
    label.current(0)

# update actuator icon state
# update_state(frame of the actuator icon, status byte of actuator) 
def update_state(frame, stat_b):
    def status():
        stat = state[stat_b]
        if stat == 0:
            frame.itemconfig(icon, fill='grey')
        elif stat == 1:
            frame.itemconfig(icon, fill='lime')
        elif stat == 2:
            frame.itemconfig(icon, fill='red')
        elif stat >= 3:
            frame.itemconfig(icon, fill='yellow')
        frame.after(1000, status)
    status()

# udate level bargraph state
# update_state_r(frame of the bargraph, status byte of bargraph)
def update_state_r(rectangle, stat_b):
    def state_r():
        rectangle.coords(bargraph, 0, abs(state[stat_b]-100), 20, 256)
        rectangle.itemconfig(b_value, text=str(state[stat_b]))
        rectangle.after(1000, state_r)
    state_r()

# cmd to PLC
# hmi_cmd(cmd (1-start/open, 2-stop/close), cmd byte)
def hmi_cmd(cmd, cmd_b):
    client.db_write(2, cmd_b, bytes([cmd]))

# animation of waterfall
def wf_anim(frame):
    def anim():
        if state[2] == 1 and state[3] != 0:
            frame.itemconfig(drop1, state='normal')
            frame.itemconfig(drop2, state='normal')
            frame.itemconfig(drop3, state='normal')
            frame.itemconfig(drop4, state='normal')
            d_coords = frame.coords(drop1)
            if d_coords[0] == 8:
                x1 = [1, 10]
                x2 = [8, 17]
            else:
                x2 = [1, 10]
                x1 = [8, 17]                
            frame.coords(drop1, x1[0], -10, x1[1], 20)
            frame.coords(drop2, x2[0], 0, x2[1], 30)
            frame.coords(drop3, x1[0], 10, x1[1], 40)
            frame.coords(drop4, x2[0], 20, x2[1], 50)
        else:
            frame.itemconfig(drop1, state='hidden')
            frame.itemconfig(drop2, state='hidden')
            frame.itemconfig(drop3, state='hidden')
            frame.itemconfig(drop4, state='hidden')
        frame.after(200, anim)
    anim()

##def shift(l, n):
##    n = n % len(l)
##    return l[n:] + l[:n]

# PLC conection
##ip = '10.100.8.12'
##tcpport = 102
##db_number = 1
##rack = 0
##slot = 1
##
##client = snap7.client.Client()
##client.connect(ip, rack, slot, tcpport)


#print (str(client.get_connected()))

# main window
win=Tk()
win.title("HMI RPI")
win.geometry('480x320')
win.attributes('-fullscreen', True)
win.wm_attributes('-alpha', .30)

conn()

# place background image
load = Image.open(os.path.dirname(os.path.abspath(__file__)) + '/HMI_RPI_BG.png')
render = ImageTk.PhotoImage(load)
bgImg = tk.Label(win, image=render)
bgImg.place(x=20, y=30)

# read actuator statuses
read_stat_db()

check_state()

# label with tag value
alarmList = tk.ttk.Combobox(win, height=10, width=60, state='readonly')
alarmList.pack()
#read_Tag_Value(tagValue)

# motor
m1 = tk.Canvas(win, height=33, width=33, bg='grey')
icon = m1.create_oval(1, 1, 32, 32)
m1text = m1.create_text(17, 17, text="M", font=('Helvetica', 16))
m1.place(x=68, y=132)
update_state(m1, 0)

# vertical valve
v1 = tk.Canvas(win, height=33, width=33)
icon = v1.create_polygon(1, 1, 32, 1, 1, 32, 32, 32, outline='black')
v1.place(x=121, y=100)
update_state(v1, 1)

# horisontal valve
v2 = tk.Canvas(win, height=33, width=33)
icon = v2.create_polygon(1, 1, 1, 32, 32, 1, 32, 32, outline='black')
v2.place(x=367, y=146)
update_state(v2, 2)

# water fall
wf = tk.Canvas(win, height=60, width=20)
drop1 = wf.create_arc(1, -10, 10, 20, outline='black', start=-135, fill='blue')
drop2 = wf.create_arc(8, 0, 17, 30, outline='black', start=-135, fill='blue')
drop3 = wf.create_arc(1, 10, 10, 40, outline='black', start=-135, fill='blue')
drop4 = wf.create_arc(8, 20, 17, 50, outline='black', start=-135, fill='blue')
wf.place(x=430, y=180)
wf_anim(wf)

# H limit
lh = tk.Canvas(win, height=15, width=15)
icon = lh.create_rectangle(0, 0, 15, 15, outline='black')
lh.place(x=250, y=60)
update_state(lh, 4)

# bar graph
b1 = tk.Canvas(win, height=100, width=20, bg='grey')
bargraph = b1.create_rectangle(1,100,21,1, fill='blue')
b_value = b1.create_text(10, 12, text="val", font=('Helvetica', 10), fill='white')
b1.place(x=270, y=65)
update_state_r(b1, 3)

#cmd buttons for motor
m_button_st = tk.Button(win, text='START', width = 4, command= lambda: hmi_cmd(1, 0), bg='lime')
m_button_st.place(x=55, y=210)
m_button_sp = tk.Button(win, text='STOP', width = 4, command= lambda: hmi_cmd(2, 0), bg='red')
m_button_sp.place(x=55, y=236)

#cmd buttons for valve vertical
m_button_st = tk.Button(win, text='OPEN', width = 3, command= lambda: hmi_cmd(1, 1), bg='lime')
m_button_st.place(x=85, y=35)
m_button_sp = tk.Button(win, text='CLOSE', width = 3, command= lambda: hmi_cmd(2, 1), bg='red')
m_button_sp.place(x=135, y=35)

#cmd buttons for valve horizontal
m_button_st = tk.Button(win, text='OPEN', width = 3, command= lambda: hmi_cmd(1, 2), bg='lime')
m_button_st.place(x=333, y=120)
m_button_sp = tk.Button(win, text='CLOSE', width = 3, command= lambda: hmi_cmd(2, 2), bg='red')
m_button_sp.place(x=383, y=120)

# exit button
exitButton = tk.Button(win, text='Exit', width = 25, command=exitProgram, bg='cyan')
exitButton.pack(side = BOTTOM)

tk.mainloop()   
